<?php
/**
* SYNTAX HIGHLIGHTER using GOOGLE CODE PRETIFY
*
* version: 1.2.1
* usage : [code]...[/code]
*
* made by eye(http://theeye.pe.kr)
* thanks to reznoa(http://reznoa.nayana.com/tt)
*/

function TheEye_ViewPostContent($target, $mother)
{
	$searchKeyword	= array('[code]', '[/code]', '&nbsp;', '<br /><br />');
	$replaceKeyword	= array('<pre class="prettyprint"><code>', '</code></pre>', ' ', '<br /> <br />');

	// for php4
	$target = eregi_replace('code]', 'code]', $target);

	$startCode	= TheEye_StrPos($target, '[code]');
	$stopCode	= TheEye_StrPos($target, '[/code]');

	$startSize	= count($startCode);
	$stopSize	= count($stopCode);

	if($startSize != $stopSize || ($startSize == 0 && $stopSize == 0))
	{
		return $target;
	}

	$offset = 0;
	$result = '';

	for($i = 0 ; $i < $startSize ; $i++)
	{
		$result .= substr($target, $offset, $startCode[$i]['start'] - $offset);
		$source  = substr($target, $startCode[$i]['start'], $stopCode[$i]['end'] - $startCode[$i]['start']);
		$result .= str_replace($searchKeyword, $replaceKeyword, $source);
		$offset  = $stopCode[$i]['end'];
	}

	$result .= substr($target, $offset);

	return $result;
}

function TheEye_HeadEnd($target)
{

	global $pluginURL;

	$content  = "<link rel=\"stylesheet\" media=\"all\" type=\"text/css\" href=\"$pluginURL/prettify.css\" />";
	$content .= "<script type=\"text/javascript\" src=\"$pluginURL/prettify.js\"></script>";

	return $target.$content;
}

function TheEye_BodyEnd($target)
{
	$content = "<script type=\"Text/javascript\">prettyPrint();</script>";

	return $target.$content;
}

function TheEye_StrPos($haystack = '', $needle = '', $offset = 0)
{
	$length = strlen($needle);
	$occurances = array();
	$count = 0;

	while(false !== ($offset = strpos($haystack, $needle, $offset)))
	{
		$occurances[$count]['start'] = $offset;
		$occurances[$count]['end'] = $offset = $offset + $length;

		$count++;
	}

	return $occurances;
}
?>
